scoreboard players operation #exp_to_gain Pet.Dummy = #player_exp_now Pet.Dummy
scoreboard players operation #exp_to_gain Pet.Dummy -= #player_exp_previous Pet.Dummy

# tellraw @a [{"text":"Player EXP gained: ","color":"blue"},{"score":{"name":"#exp_to_gain","objective":"Pet.Dummy"}}]

function pets:handler/pet/leveling/read_pet_data with entity @s item.components."minecraft:profile".properties[3]
function pets:handler/pet/leveling/read_pet_level with entity @s item.components."minecraft:profile".properties[2]
data modify storage pets leveling.name set from entity @s item.components."minecraft:profile".properties[1].value
execute if score #current_level Pet.Dummy matches 100.. run return fail

# tellraw @a [{"text":"current_exp: "},{"score":{"name":"#current_exp","objective":"Pet.Dummy"}}]
# tellraw @a [{"text":"exp_to_next_level: "},{"score":{"name":"#exp_to_next_level","objective":"Pet.Dummy"}}]
# tellraw @a [{"text":"level: "},{"score":{"name":"#current_level","objective":"Pet.Dummy"}}]

scoreboard players operation #current_exp Pet.Dummy += #exp_to_gain Pet.Dummy
execute if score #current_exp Pet.Dummy < #exp_to_next_level Pet.Dummy run scoreboard players operation #current_exp Pet.Dummy += exp_to_gain Pet.Dummy
execute if score #current_exp Pet.Dummy >= #exp_to_next_level Pet.Dummy run function pets:handler/pet/leveling/level_up

# --------------------------------------------------------------------------------- #

execute store result storage pets leveling.current_exp int 1 run scoreboard players get #current_exp Pet.Dummy
execute store result storage pets leveling.exp_to_next_level int 1 run scoreboard players get #exp_to_next_level Pet.Dummy

data modify entity @s item.components."minecraft:profile".properties[3].value set string storage pets leveling.current_exp
data modify entity @s item.components."minecraft:profile".properties[3].signature set string storage pets leveling.exp_to_next_level

# --------------------------------------------------------------------------------- #
# Update the pet's level and name in the database
# Storage minecraft:pets has the following contents: {current_exp: 11, exp_to_next_level: 15, name: "Phoenix", level: 2}

# scoreboard players operation #Search ID = @s ID
execute store result storage pets leveling.TempID int 1 run scoreboard players get @s ID
function pets:handler/pet/leveling/update_database with storage pets leveling