execute at @s run playsound minecraft:entity.player.levelup master @s ~ ~ ~ 1 1.5
# say hi

# --------------------------------------------------------------------------------- #

scoreboard players operation #current_exp Pet.Dummy -= #exp_to_next_level Pet.Dummy
scoreboard players operation #exp_to_next_level Pet.Dummy *= #next_level_operation Pet.Dummy
scoreboard players add #current_level Pet.Dummy 1

execute as @a[tag=Owner] at @s if score #current_level Pet.Dummy matches 100.. run playsound minecraft:ui.toast.challenge_complete master @s ~ ~ ~ 1 1.2
execute if score #current_level Pet.Dummy matches 100.. run tellraw @a [{"selector":"@a[tag=Owner, limit=1]","color":"white"},{"text":" has completed the challenge ","color":"white"},{"text":"[Divine Beast Tamer]","color":"gold","hoverEvent":{"action":"show_text","contents":[{"text":"Divine Beast Tamer\nReach level 100 with any pet.","color":"gold"}]}},{"text":"!","color":"white"}]
# tellraw @a [{"text":"level: "},{"score":{"name":"#current_level","objective":"Pet.Dummy"}}]

# --------------------------------------------------------------------------------- #
# Update the pet's level and name

scoreboard players operation #Search ID = @s ID
tellraw @a[tag=Owner] [{"text":"- Your ","color":"green"},{"nbt":"item.components.\"minecraft:profile\".properties[1].value","entity":"@e[type=item_display, tag=Pet, predicate=pets:check_id, limit=1]", "color":"aqua"},{"text":" has reached level "},{"score":{"objective":"Pet.Dummy","name":"#current_level"}, "color":"aqua"},{"text":"."}]

execute store result storage pets leveling.level int 1 run scoreboard players get #current_level Pet.Dummy
data modify entity @s item.components."minecraft:profile".properties[2].value set string storage pets leveling.level

function pets:handler/pet/leveling/write_to_pet with storage pets leveling
data modify entity @s item.components."minecraft:custom_name" set from entity @s CustomName

# --------------------------------------------------------------------------------- #

# tellraw @a [{"text":"current_exp: "},{"score":{"name":"#current_exp","objective":"Pet.Dummy"}}]
# tellraw @a [{"text":"exp_to_next_level: "},{"score":{"name":"#exp_to_next_level","objective":"Pet.Dummy"}}]
# tellraw @a [{"text":"level: "},{"score":{"name":"#current_level","objective":"Pet.Dummy"}}]