execute as @a unless score @s ID matches 0.. run function pets:handler/database/set_id

execute as @e[type=wandering_trader, tag=!HasPetKey] run function pets:update_wandering_trader

execute as @a[tag=ActiveMenu] at @s positioned ~ ~1 ~ run function pets:handler/menu/follow
execute as @a[tag=InMenu] at @s if predicate pets:interact_with_menu run function pets:handler/menu/detection/listener

# --------------------------------------------------------------------------------- #

execute as @a run attribute @s generic.gravity base set 0.08
execute as @a run attribute @s generic.attack_speed base set 4
execute as @a run attribute @s player.sneaking_speed base set 0.3

execute as @a run scoreboard players operation #player_exp_now Pet.Dummy = @s Var.Player.EXP
execute as @a[tag=ActivePet] at @s run function pets:handler/pet/ai
execute as @a run scoreboard players operation #player_exp_previous Pet.Dummy = @s Var.Player.EXP

# --------------------------------------------------------------------------------- #

execute as @a run function pets:handler/menu/clear
execute as @e[type=chest_minecart, tag=PetMenu] at @s unless entity @p[distance=..5] run kill @s

# --------------------------------------------------------------------------------- #

execute as @a[advancements={pets:checks/player_hurt_entity=true}] run advancement revoke @s only pets:checks/player_hurt_entity